# !/usr/bin/env python
# -*- coding: utf-8 -*-

import wave
import pyaudio
import time
from array import array
#from struct import unpack, pack

import os
import shutil
import threading
import gobject
gobject.threads_init()


dir_tmp  = os.path.join(os.path.expanduser("~") ,".sece/")
dir_dest = os.path.join(os.path.expanduser("~") ,"sece/")

try:
    os.mkdir(dir_tmp)
except:
    pass #el directorioya estaba creado

try:
    os.mkdir(dir_dest)
except:
    pass #el directorioya estaba creado


def create_stream(tipo,p,formato,wf,canales,ratio,io,chunk): 
    """Procedimiento para Crear el stream, tiene separado si es 
    para lectura de audio o escritura"""
    
    if tipo=="writer":
        try:
            stream=None
            stream = p.open(format=formato, channels=canales, 
                    rate=ratio, input= io, frames_per_buffer=chunk)
            print "Stream de Entrada Creado"    
        except:
            print "No se ha podido crear Stream de entrada"

        return stream
    else:
        try:
            stream=None
            stream=p.open(format = p.get_format_from_width(wf.getsampwidth()),
                channels = wf.getnchannels(),
                rate = wf.getframerate(),
                output = True)
            print "Stream de Entrada Creado"    
        except:
            print "No se ha podido crear Stream de entrada"

        return stream   
    

def reader_writer(tipo,fichero,canal,p,formato,ratio,data,chunk): 
    """Convierte la onda de audio, leída del stream creado 
    anteriormente, a una lista de elementos, separa si es para lectura
    o escritura""" 
    
    if tipo == "reader":
        try:
            #wf=wave.open("sonido/record1.wav", 'rb')
            #wf=wave.open("sonido/" + fichero, 'rb')            
            
            wf=wave.open(dir_tmp + fichero, 'rb') 
            print dir_tmp+fichero
                       
        except Exception,error:
            print error
            
            
            
        
        data=[]
        data_e = wf.readframes (chunk)
        while data_e != '':
            data.append(data_e)
            data_e = wf.readframes(chunk)
        print "Reader Creado..."    
        
        return data,wf
        
    else:
        try:
            wf = wave.open(dir_tmp + fichero, 'wb')
            wf.setnchannels(canal)
            wf.setsampwidth(p.get_sample_size(formato))
            wf.setframerate(ratio)
            wf.writeframes(data)
            wf.close()
            if fichero!="record1.wav":
                try:
                    orig=dir_tmp + fichero
                    #dest=os.path.expanduser("~")
                    dest = os.path.join(os.path.expanduser("~") ,"sece/")
                    shutil.copy(orig,dest)                
                    if os.path.exists("/homeInst/instituto/sece"):                   
                        carp_nia= "/homeInst/instituto/sece/" + os.path.splitext(fichero)[0]
                        try:
                            os.mkdir(carp_nia)
                        except:
                            pass #el directorioya estaba creado
                        try:    
                            shutil.copy(orig,carp_nia)
                            os.remove(orig)
                        except:
                            pass #error al copiar
                    else:
                        if os.path.exists("/compartida/sece"):
                            carp_nia= "/compartida/sece/" + os.path.splitext(fichero)[0]
                            try:
                                os.mkdir(carp_nia)
                            except:
                                pass #el directorioya estaba creado
                            try:
                                shutil.copy(orig,carp_nia)
                                os.remove(orig)
                            except:
                                pass #error al copiar
                except:
                    print "Error al copiar archivo"
                
        except:
            print "No se ha podido grabar a disco"  

def limpiar(stream,wave,p):
        """Finaliza las librerías y libera los recursos bloqueados por
        el hilo"""
        print "entra en limpiar"
        try:
            #stream_out.close()
            stream.close()
        except:
            pass
        try:    
            wave.close()
        except:
            pass
        try:
            p.terminate()
            print terminado
        except:
            pass
    
    

class recorder(threading.Thread):
    """Clase que se encarga del funcionamiento completo del grabador"""
    def __init__(self,fic,SECONDS):

        threading.Thread.__init__(self)
        
        self.chunk = 1024
        
        self.FORMAT = pyaudio.paInt16
        self.CHANNELS = 1
        #self.RATE = 44100
        self.RATE = 11025 #calidad tlf:8000 , calidad radio:22050
        self.THRESHOLD = 100
        self.MAX_THRESHOLD = 32767
        self.status="stop"
        self.fin=False
        self.fichero=fic

        self.RECORD_SECONDS = SECONDS + 1  #Puesto que empieza en 0
        self.posicion=0
        self.posicion_ult = int(float(self.RATE) / self.chunk * self.RECORD_SECONDS)
        self.p = pyaudio.PyAudio()
        self.stream=None
        self.data_inst=0
        
        
        
        

        self.start()

    
    def set_tiempo_grab(self,tiempo):
        """Modifica el tiempo durante el cual se grabará el audio"""
        
        self.RECORD_SECONDS=tiempo+1
        self.posicion_ult=int(float(self.RATE) / self.chunk * self.RECORD_SECONDS)
 
    def get_size(self):
        """Devuelve el número de posiciones de la lista de datos, en
        función del tiempo de grabación"""
        
        return int(float(self.RATE) / self.chunk * self.RECORD_SECONDS)
    
    
    
    def get_porcentaje(self):
        """Devuelve el porcentaje de grabación en función de la posición
        en la que se encuentre la lista"""
        
        if self.posicion==0:
            return 0.0
        else:
            #float para que el resultado este con decimales
            return  float(self.posicion/(float(self.RATE) / self.chunk * self.RECORD_SECONDS)) 
    
    
    def GetInHMS(self,seconds):
       """Convierte el número de segundos al formato HMS"""
       
       #return time.strftime('%H:%M:%S', time.gmtime(seconds))
       
       return time.strftime('%M:%S', time.gmtime(seconds))

                    
    def tiempo(self,pos):
        """Devuelve el tiempo que lleva la grabación en función de la
        posición en la lista"""
        try:          
          return (self.GetInHMS(pos*self.chunk/self.RATE))
        except:
            return "00:00"
            
    
    
    def get_status(self):
        """Devuelve el estado en el que se encuentra el reproductor
        (play/pause...)"""
        
        return self.status    
    

    def get_vol(self,datavol):
        """Devuelve el volúmen de la entrada de audio"""
        
        if datavol!=0:
            convert = array('h', datavol)
            return float((max(convert)*100)/self.MAX_THRESHOLD)/100
        else:
            return 0 
  
          
    def stop(self):
        """Maneja la acción de stop"""
        
        self.status="stop"
        
    def grabar(self):
        """Maneja la acción de grabar"""
        
        self.status="grabar"    

    def pausa(self):
        """Maneja la acción de pausar la grabación"""
        
        self.status="pausa"

        
        
        
    def run(self):
        """Método run del hilo que se crea y que contiene el bucle 
        principal donde se encuentar la lógica principal del 
        grabador"""        
        
        while not self.fin:                      
            if self.get_status()=="grabar":

                """"Nuevo"""
                
                self.posicion=0
                self.posicion_ult = int(float(self.RATE) / self.chunk * self.RECORD_SECONDS)
                self.p = pyaudio.PyAudio()
                self.stream=None
                self.data_inst=0

                """/Nuevo"""
                
                self.stream=create_stream("writer",self.p,self.FORMAT,"",self.CHANNELS,self.RATE,True,self.chunk)
                all = []
                tiempo_ant=0
                self.posicion=0

                print "inicia"
                while self.posicion < self.posicion_ult:
                #for self.posicion in range(0, self.posicion_ult):
                    #try:  
                    
                    if self.fin == True:
                        break
                    data = self.stream.read(self.chunk)
                    self.data_inst=data
                    
                    tiempo=self.tiempo(self.posicion)
                    if tiempo!=tiempo_ant:
                        tiempo_ant=tiempo
                        print  tiempo,"/",self.tiempo(self.posicion_ult),self.get_vol(data)
                        
                        
                   

                    #Añadido, si pulsa salir pero quiere continuar después
                    if self.status!="pausa":
                        all.append(data)
                        self.posicion=self.posicion + 1
                        
                print "sale"
                limpiar(self.stream,"",self.p)        
                data = ''.join(all)
                reader_writer("writer",self.fichero,self.CHANNELS,self.p,self.FORMAT,self.RATE,data,"")
                self.stop()
                self.data_inst=0
                tiempo_ant=0
                self.posicion=0

    def finaliza(self):
        """Finaliza el bucle principal para terminar el programa"""
        self.fin = True
        print "fin"
      


if __name__ == "__main__"  :

    accion=""
    b=recorder("record1.wav",3)

    while accion!="quit":

       
       
    
   
        print "intro una accion(record/quit)"," recorder:",b.get_status()
        accion=raw_input()
    
        if accion=="record":
            b.grabar()      
