# !/usr/bin/env python
# -*- coding: utf-8 -*-
##############################################################################
# Project:     Agencia
# Module:      librep.py
# Purpose:     Módulo para la reproducción de ficheros de audio wav.
# Language:    Python 2.6
# Date:        22-Nov-2011.
# Ver.:        22-Nov-2011.
# Author:    Rafael J. García Perdigón
# Copyright:  2011 - Rafael J. García Perdigón
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
##############################################################################

import wave
import pyaudio
import time

import os


import threading
import gobject
gobject.threads_init()

dir_tmp=os.path.join(os.path.expanduser("~") ,".sece/")

class audio(threading.Thread):
    def __init__(self,fic=None):
        
        self.fin = False
        self.fichero = fic
        
        if fic != None:
            threading.Thread.__init__(self)
            self.data = []
            self.CHUNK= 1024        
            self.stream_out = None
            self.wave=None
            self.status="stop"
            self.posicion=0
            self.direccion="dere"
            self.velocidad=1
            self.unlock=False
            self.online=False
            self.p = pyaudio.PyAudio()
            self.reader()
            self.create_stream_out()
            self.start()        
        
    def ponerFichero (self,fic):
        if self.fichero == None:
            self.fichero = fic
            self.fin = False
            threading.Thread.__init__(self)
            self.data = []
            self.CHUNK= 1024        
            self.stream_out = None
            self.wave=None
            self.status="stop"
            self.posicion=0
            self.direccion="dere"
            self.velocidad=1
            self.unlock=False
            self.online=False
            self.p = pyaudio.PyAudio()
            self.reader()
            self.create_stream_out()
            self.start()        


    def reader(self): 
        try:
            #self.wave=wave.open("sonido/listening1.wav", 'rb')
            #self.wave=wave.open("./sonido/" + self.fichero, 'rb')
            #self.wave=wave.open("/tmp/" + self.fichero, 'rb')
            
            self.wave=wave.open(dir_tmp + self.fichero, 'rb')
            
        except Exception,error:
            print error
            self.limpiar()
 
        data=[]
        data = self.wave.readframes (self.CHUNK)
        while data != '':
            self.data.append(data)
            data = self.wave.readframes(self.CHUNK)
        
        print "Reader Creado..."
        
    def create_stream_out(self): 
        #Si abierto lo cierro.
        try:
            self.stream_out.close()
        except:
            pass
   
        self.stream_out = self.p.open(format =
                self.p.get_format_from_width(self.wave.getsampwidth()),
                channels = self.wave.getnchannels(),
                rate = self.wave.getframerate(),
                output = True)
                
        self.online=True
        print "Stream Creado..."
    
    
    def GetInHMS(self,seconds):
        hours = seconds / 3600
        seconds -= 3600*hours
        minutes = seconds / 60
        seconds -= 60*minutes
        if hours == 0:
            return "%02d:%02d" % (minutes, seconds)
            return "%02d:%02d:%02d" % (hours, minutes, seconds)
    
    
    def tiempo(self,pos):

        try:
            return (self.GetInHMS(pos*self.CHUNK/self.wave.getframerate()))
        except:
            return "00:00"

    
    def get_size(self):
        return int(len(self.data))      
        
    def get_porcentaje(self):
        if self.posicion==0:
            return 0.0
        else:
            return  self.posicion/float(len(self.data)) #float para que el resultado este con decimales
        
    def play(self):
            
        self.direccion="dere"
        self.status="play"
        self.velocidad=1
        self.unlock=True
        
    def stop(self):
        self.posicion=0
        self.status="stop"
        self.direccion="dere"
        self.velocidad=1
        self.unlock=False
    
    def pause(self):      
        self.status="pause"
        self.direccion="dere"
        self.velocidad=1
        self.unlock=False 
    
    def rewind(self):
        self.status="rewind"
        self.direccion="izq"
        self.velocidad=5
        self.unlock=True
                
    def forward(self):
        self.status="forward"
        self.direccion="dere"
        self.velocidad=5
        self.unlock=True

    def get_status(self):
        return self.status
    
    def control(self):

        if self.status=="play":
            self.play()
            if self.posicion>=len(self.data):
                self.stop()
            
        if self.status=="forward":
            self.forward()
            if self.posicion>=len(self.data):
                self.stop()
                
        if self.status=="rewind":
            self.rewind()
            if self.posicion<=0:
                self.stop()
                    
        if self.status=="stop":
            self.stop()

        if self.status=="pause":
            print "pause2"
        
    def operacion(self):
        if self.direccion=="dere":
            self.posicion = self.posicion + self.velocidad
        else:   
            self.posicion = self.posicion - self.velocidad
            
    def run(self):        
        #print "FRAMES:",self.wave.getframerate(),"CHUNK:",self.CHUNK,"ELEM:",self.get_size(),"Tiempo Total:",self.tiempo(len(self.data))
        tiempo_ant=0
        self.posicion=0
        while not self.fin:
            while self.unlock and not self.fin:
                if not self.online: 
                    self.data=[]
                    self.p = pyaudio.PyAudio()
                    self.reader()
                    self.create_stream_out()    
                    print "FRAMES:",self.wave.getframerate(),"CHUNK:",self.CHUNK,"ELEM:",self.get_size(),"Tiempo Total:",self.tiempo(len(self.data))
                    self.online=True
                self.control()
                self.stream_out.write(self.data[self.posicion] )
                self.operacion()
                tiempo=self.tiempo(self.posicion)
                if tiempo!=tiempo_ant:
                    tiempo_ant=tiempo
                    print  tiempo,"/",self.tiempo(len(self.data))

            if self.online:
                print "pasa a Offline"
                self.limpiar()
                data=[]
                self.online=False
                
            tiempo_ant=0
            
        self.limpiar()

    def limpiar(self):
        try:
            self.stream_out.close()
        except:
            pass
        try:    
            self.wave.close()
        except:
            pass
        try:
            self.p.terminate()
        except:
            pass

    def finaliza(self):
        self.fin = True
            
def controller(data,obj):
    
    if data=="play":
        if obj.get_status()=="stop":
            obj.play()
        else:
            if obj.get_status()=="play":
                obj.pause()
            else:
                if obj.get_status()=="pause":
                    obj.play()      
                else:
                    if obj.get_status()=="rewind":
                        obj.play()
                    else:
                        if obj.get_status()=="forward":
                            obj.play()
                                
     
    if data=="stop":
        obj.stop()   
        
    if data=="rewind":    
        obj.rewind()

    if data=="forward":
        obj.forward()    

    print "data:",data,"estatus",obj.get_status()       

            

if __name__ == "__main__"  :
    a=audio("listening1.wav")
    while True:
        print "intro una accion",a.status
        accion=raw_input()
        if accion=="play":
            a.play()
        else:
            a.stop()
