#!/usr/bin/env python
# -*- coding: utf-8 -*-
##############################################################################
# Project:     Agencia
# Module:      listening.py
# Purpose:     Entorno grafico para pruebas de ingles.
# Language:    Python 2.6
# Date:        15-Nov-2011.
# Ver.:        15-Nov-2011.
# Author:    Isabel Aparicio Pérez
# Copyright:    2011 - Isabel Aparicio Pérez    <prog5pe@edu.juntaextremadura.net>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later versiocn.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
##############################################################################

import gtk
import pygtk
import sys
import os
import glob
import shutil
import tempfile
import subprocess
import ConfigParser
import zipfile

config = ConfigParser.ConfigParser()
fich_conf=os.path.expanduser("~") + "/" + ".agencia_default_2013.cfg"

def get_ip_inet_address(connection_ip='198.41.0.4'):
   import socket
   """Returns the ip address of the interface used to connect to the given ip
   
   198.41.0.4 is a DNS ROOT Server, so it's the default value to connect to Internet
   """
   s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)  
   try:
       s.connect((connection_ip, 0))
       inet_address= s.getsockname()[0]
       nombre=socket.gethostbyname_ex(socket.gethostname())[0].split(".")
       if len(nombre)>1:
           dom=nombre[1]
       else:
           dom ='sindominio'
   except:
       inet_address=''
       dom=''
   s.close()
                
   return dom + '-' + inet_address


if not config.read(fich_conf):
    print "No existe el archivo de configuración, se creará en el home del usuario"
    config.add_section("Ruta")
    config.set("Ruta","ruta_ant",os.path.expanduser("~"))
    config.add_section("Prueba")
    config.set("Prueba","test","False")
    f=open(fich_conf,"w")
    config.write(f)
    f.close()


try:
    import agencia.mp3windows as mp3windows
except:
    pass #sin soporte de mp3 en windows
    
#Módulo realizado con pyaudio para realizar la reprodución
import agencia.librep as librep

import platform

if platform.system()=="Linux":
    os.system("preparacion_alsa.sh")



import gobject
gobject.threads_init()


dir_tmp=os.path.join(os.path.expanduser("~") ,".sece")

try: #limpiamos archivos anteriores
    os.removedirs(dir_tmp)
except:
    pass #no había archivos

try:
    os.mkdir(dir_tmp)
except:
    pass #el directorioya estaba creado


#import zipfile

class listening:
    def crearVentana(self,titulo,X,Y):
    ##crea una ventana con el titulo y el tamaño pasados como parametros
        self.ventana= gtk.Window(gtk.WINDOW_TOPLEVEL)#
        self.ventana.set_size_request(X, Y)
        self.ventana.set_title(titulo) 
        self.ventana.show()
        self.ventana.maximize()
        return self.ventana
        
    
    def creaCaja(self,vertical,homogeneo,espacio):
    #crea una caja vertical u horizontal dependiendo del valor pasado en el argumento Vertical
    #estas cajas las vamos a usar para colocar los widgets dentro de las ventanas.
        if vertical==True:
            self.box=gtk.VBox(homogeneo,espacio)
        else:
            self.box=gtk.HBox(homogeneo,espacio)
        self.box.show()
        return self.box
    
    def creaTabla(self,filas,columnas,homogeneo):
    #crea una tabla para empaquetar widgets del tamaño filas y columnas pasados como argumentos
        self.tabla=gtk.Table(filas,columnas,homogeneo)
        self.tabla.show()
        return self.tabla
  
    def creaEtiqueta(self,texto,X,Y,alineacion,partido):
    ##se encarga de crear una etiqueta con el texto que se le pasa como parametro del 
    #tamaño X x Y con la alineacion que se le pase y tambien si realiza el particionado de
    #las lineas de forma automatica o no
        self.etiqueta=gtk.Label(texto)
        self.etiqueta.set_size_request(X,Y)
        self.etiqueta.set_justify(alineacion)
        self.etiqueta.set_line_wrap(partido)
        self.etiqueta.show()
        return self.etiqueta
      
    def creaBoton(self,nombre,stock,x,y):
    #crea un boton normal con el nombre y el stock predeterminado y ademas se les pasa tamaño para
    #redimensionar el boton 
        self.boton=gtk.Button(nombre,stock)
        self.boton.set_size_request(x,y)
        self.boton.show()
        return self.boton
        
    def creaCajaTexto(self,maximo,x,y,visible):
    #crea una caja que recoge un texto, podemos ponerle un tamaño maximo al texto que recoge en maximo
    #x e y son los parametros para dimensionar la caja de texto, tambien establecemos si el texto va a ser visible
    #o va a mostrar puntos
        self.entrada=gtk.Entry(maximo)
        self.entrada.set_size_request(x,y)
        self.entrada.set_visibility(visible)
        self.entrada.show()
        return self.entrada
  
    def creaCajaBotones(self,horizontal,disposicion,espacio):
    #creamos una barra de botones horizontal o vertical dependiendo del valor del argumento horizontal
    #y ademas le pasamos el parametro disposicion que nos va a indicar el estilo de la barra de botones
        if horizontal==True:
            self.cajaboton=gtk.HButtonBox()
        else:
            self.cajaboton=gtk.VButtonBox()
        self.cajaboton.set_layout(disposicion)
        self.cajaboton.set_spacing(espacio)
        self.cajaboton.show()
        return self.cajaboton
  
    def creaFrame(self,titulo,estilo):
    #crea un marco con el titulo y el estilo pasados por parametros
        self.frame=gtk.Frame(titulo)
        self.frame.set_shadow_type(estilo)
        self.frame.show()
        return self.frame
  
    def creaImagen(self,ruta):
        self.imagen = gtk.Image()
        self.imagen.set_from_file(ruta)
        self.imagen.show()
        return self.imagen
  
  
     
    def cerrarVentana(self,widget,data):
    #con esto se cierra la ventana activa
        self.ventana.destroy()
          
    def borradoevento(self,widget,data):
    ##pregunta antes de cerrar la ventana, si le decimos que no no cierra el dialogo
        texto="   ¿Esta seguro de que desea salir de la aplicación?" 
        dialogo=gtk.MessageDialog(self.ventana, gtk.DIALOG_MODAL,gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO,texto)
        dialogo.show() 
        respuesta = dialogo.run()
        dialogo.destroy()
        if respuesta == gtk.RESPONSE_YES:
            dialogo.destroy()
            self.ventana.destroy()
            destruccion=False
            if config.get("Prueba","test")=="True":
               codigo = get_ip_inet_address()
            
                   
               texto="Para comunicar a la Servicio de Evaluación y Calidad Educativa que se ha " +\
                     "realizado la prueba, deberá rellenar el formulario que se encuentra en http://sece.educarex.es/ \r\r" +\
                     "Para acceder, necesitará estos datos: \r" +\
                     "Usuario: docente \r" +\
                     "Contraseña: docente \r\r\r" +\
                     "En el formulario se le pedirá el código de centro, por lo que es necesario tenerlo presente antes de entrar en la web. \r"         
               #texto1="<span foreground='red' size='larger'>Nota: Este código no volverá a ser notificado.</span> \r\r"
               texto2="Muchas gracias por su colaboración."
                 
               
                            
               #dialogo=gtk.MessageDialog(self.ventana, gtk.DIALOG_MODAL,gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,texto)
               dialogo=gtk.MessageDialog(self.ventana, gtk.DIALOG_MODAL,gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,None)               
              
               dialogo.set_markup(texto+texto2)
               
               
         
               dialogo.show()
               respuesta = dialogo.run()
                              
               dialogo.destroy()
               
               try:
                    import webbrowser
                    webbrowser.open('http://secex.educarex.es')
               except:
                   pass
                                       
               config.set("Prueba","test", "Satisfactorio")               
               f = open(fich_conf, "w")
               config.write(f)
               f.close()
        else:
            dialogo.destroy()
            destruccion=True
        return destruccion

    def muestraMensaje (self,widget,data):
        dialog = gtk.MessageDialog (self.ventana,
                                       gtk.DIALOG_DESTROY_WITH_PARENT,
                                       gtk.MESSAGE_ERROR,
                                       gtk.BUTTONS_CLOSE,
                                       data);
        dialog.show()
        dialog.run()
        dialog.destroy()
        
    def destruir(self,widget,data):
    #cierra el programa
        gtk.main_quit()
        
    def destruir_rep(self,widget,data,rep):
    #cierra el programa
        rep.finaliza()
        gtk.main_quit()
        
  
    def ayudar(self,widget,data):
    ##boton de ayuda de la ventana 
        texto="En el cuadro de texto deberá introducir la clave de pruebas si desea testear el programa, o bien la de examen para comenzar la prueba"
        dialogo=gtk.MessageDialog(self.ventana, gtk.DIALOG_MODAL,gtk.MESSAGE_INFO, gtk.BUTTONS_OK,texto)
        dialogo.show()
        respuesta = dialogo.run()
        dialogo.destroy()
        
 
    def reproductor(self,widget,data):
    ####AQUI HABRA QUE LLAMAR A UNA FUNCION QUE HAGA LAS COMPROBACIONES DE LOS 
    #####LOGIN, COMPROBARA QUE SEA IGUAL, DISCRIMINARA SI SE HA INTRODUCIDO
    #####LA CONTRASEÑA DE PRUEBA O LA CONTRASEÑA DE EXAMEN O SI HA HABIDO ERROR.
    #####EN CASO DE QUE SE PRODUZCA ERROR DEBE VOLVER A LA FUNCION PEDIRCLAVE.
    ######EN CASO DE QUE HAYA INTRODUCIDO LA CLAVE CORRECTA QUE DEVUELVA EL FICHERO
    #####QUE HAY QUE TRATAR Y DEVUELVA EL CONTROL A ESTA FUNCION.
        self.ventanaclave.hide()
        self.ventanareproductor=self.crearVentana("Prueba de comprensión oral",600,400)
        tabla=self.creaTabla(8,8,True)

        barratitulo=self.creaCajaBotones(True,gtk.BUTTONBOX_SPREAD,2)

        marco=self.creaFrame("Servicio de Evaluación y Calidad Educativa",gtk.SHADOW_IN)

        #marco2=self.creaFrame("",gtk.SHADOW_IN)
        
        #tabla.attach(marco,1,2,1,2,True,True,0)

        #tabla.attach(marco2,1,2,1,2,True,True,0)

        image = gtk.Image()
        pixbuf = gtk.gdk.pixbuf_new_from_file("./iconos/edexcomprension.jpg")
        scaled_buf = pixbuf.scale_simple(145,145,gtk.gdk.INTERP_BILINEAR)
        image.set_from_pixbuf(scaled_buf)

        
        image.show()

        #marco2.add(image)
        
    ##en esta etiqueta en vez de el texto lo que tendremos que poner sera el nombre del fichero
    ##que se este reproduciendo en el momento pero por ahora pongo un texto
        texto = data
        etiqueta=self.creaEtiqueta(texto,250,50,gtk.JUSTIFY_LEFT,True)
        marco.add(etiqueta)

        barratitulo.add(image)
        barratitulo.add(marco)
        tabla.attach(barratitulo,1,7,1,2,True,True,0)
            
        self.ventanareproductor.add(tabla)
  
        
    
    ##Creamos la barra de progreso de avance de la reproducción
        self.barraprogreso = gtk.ProgressBar(adjustment=None)
        self.barraprogreso.set_usize(560, 40)
        #tabla.attach(self.barraprogreso,1,7,6,7,True,True,0)
        tabla.attach(self.barraprogreso,1,7,1,7,True,True,0)
        self.barraprogreso.show()
        
        
    ##creamos una barra de botones y añadimos los botones correspondientes al reproductor
        barrabotones=self.creaCajaBotones(True,gtk.BUTTONBOX_SPREAD,10)
            
    #Creamos instancia de la clase audio.
        #self.repro=librep.audio(texto)
        
        
        archivo_audio=os.path.join(dir_tmp,"listening1.wav")
        if not os.path.exists(archivo_audio): archivo_audio=os.path.join(dir_tmp,"listening1.mp3")
        self.winmp3= (os.path.splitext(archivo_audio)[1].lower()=='.mp3' and os.name!='posix' )
        if self.winmp3:         
            self.repro=mp3windows.AudioClip(archivo_audio)
            self.repro.volume(100)          
        else:
            self.repro=librep.audio(archivo_audio)
        
    #Barra de progreso de la reproducción
        self.proc_barra()
        
    # ****** BOTON_ATRAS
        imagenatras = self.creaImagen("./iconos/atras.png")
        botonatras = gtk.Button()
        botonatras.add(imagenatras)
        #self.botonatras.connect("clicked",self.clickenatras)
        botonatras.connect("clicked", self.callback, self.repro, "rewind")
        botonatras.show()
        barrabotones.add(botonatras)
        
    # ****** BOTON PLAY
        imagenplay = self.creaImagen("./iconos/play.png")
        botonplay = gtk.Button()
        botonplay.add(imagenplay)
        #self.botonplay.connect("clicked",self.clickenplay_pausa)
        botonplay.connect("clicked", self.callback, self.repro, "play")
        botonplay.show()
        barrabotones.add(botonplay)

    # ****** BOTON SIGUIENTE
        imagensiguiente = self.creaImagen("./iconos/siguiente.png")
        botonsiguiente = gtk.Button()
        botonsiguiente.add(imagensiguiente)
    #self.botonsiguiente.connect("clicked",self.clickensiguiente)
        botonsiguiente.connect("clicked", self.callback, self.repro, "forward")
        botonsiguiente.show()
        barrabotones.add(botonsiguiente)

    # ****** BOTON STOP
        imagenstop = self.creaImagen("./iconos/stop.png")
        botonstop = gtk.Button()
        botonstop.add(imagenstop)
        #self.botonstop.connect("clicked",self.clickenstop)
        botonstop.connect("clicked", self.callback, self.repro, "stop")
        botonstop.show()
        barrabotones.add(botonstop)
  
    # ****** BOTON PAUSA
        #imagenpausa = self.creaImagen("./iconos/pausa.png")
        #botonpausa = gtk.Button()
        #botonpausa.add(imagenpausa)
        #self.botonstop.connect("clicked",self.clickenpausa)
        #botonpausa.connect("clicked", self.callback, self.repro, "play")
        #botonpausa.show()
        #barrabotones.add(botonpausa)
  
    # ****** BOTON SONIDO
        #imagensonido = self.creaImagen("./iconos/sonido.png")
        #botonsonido = gtk.Button()
        #botonsonido.add(imagensonido)
        #self.botonstop.connect("clicked",self.clickenpausa)
        #botonsonido.show()
        #barrabotones.add(botonsonido)

        tabla.attach(barrabotones,1,7,5,6,True,True,0)


      # ****** BOTON VOLVER   
        barra_sal_vol=self.creaCajaBotones(True,gtk.BUTTONBOX_SPREAD,2)
        imagenvolver= self.creaImagen("./iconos/volver.png")
        botonvolver = gtk.Button()
        botonvolver.add(imagenvolver)
        imagensalir= self.creaImagen("./iconos/salir.png")
        botonvolver.show()
        
        botonvolver.connect("clicked",self.callback,self.repro,"volver")
        #botonvolver.connect("clicked",self.pedirClave,None)
     
     # ****** BOTON SONIDO
        botonsalir = gtk.Button()
        botonsalir.add(imagensalir)
        botonsalir.show()
        botonsalir.connect("clicked", self.callback, "", "salir")

        barra_sal_vol.add(botonvolver)
        barra_sal_vol.add(botonsalir)
        tabla.attach(barra_sal_vol,6,7,6,8,True,True,0)
        
        
        self.ventanareproductor.connect("delete_event",self.borradoevento)
        self.ventanareproductor.connect("destroy",self.destruir_rep,None,self.repro)
        
    def callback(self, widget, rep, data):
    #Función para llamar a las acciones de cada botón del reproductor   

        if data !="salir" and data!="volver":           
            if self.winmp3:
                func=getattr(rep,data)
                func()
            else:
                librep.controller(data,rep)
            
            #Se añade la llamada al proceso barra para que si se pulsa 
            #muchas veces a play y se congela el hilo de gobjetc, se
            #vuelva a recargar. 

            self.proc_barra()

        
        
        if data=="salir":
           self.borradoevento(self.ventanareproductor,"delete_event") 
        
        if data=="volver":          
            
            self.ventanareproductor.hide()
            rep.finaliza()
            self.pedirClave(None,None)
            
            
    def proc_barra(self):
        self.barraprogreso.set_fraction(self.repro.get_porcentaje())
        if self.repro.mp3:
            #text=str(self.repro.tiempo(self.repro.posicion))+ "/" +str(self.repro.GetInHMS(int(self.repro.mf.total_time()/1000)))
            text = str("Duración: " + str(self.repro.GetInHMS(int(self.repro.mf.total_time()/1000))))
        else:    
            text=str(self.repro.tiempo(self.repro.posicion))+ "/" +str(self.repro.tiempo(self.repro.get_size())) #+"----"+str(rep.get_porcentaje())
        self.barraprogreso.set_text(text)         
        if self.repro.status == "stop":
            self.repro.stop()
        else:
            gobject.timeout_add(100, self.proc_barra)             

    def pedirClave(self,widget,data):        
        
        self.ventanappal.hide()
        self.ventanaclave=self.crearVentana("Clave",400,200)
        #self.ventanaclave.maximize()
        tabla=self.creaTabla(9,8,True)
        self.ventanaclave.add(tabla)
        texto= "Introduzca la clave"
        etiqueta=self.creaEtiqueta(texto,350,100,gtk.JUSTIFY_FILL,True)        
        tabla.attach(etiqueta,1,7,1,2,True,True,0)
        self.contra1=self.creaCajaTexto(14,300,30,True)
        tabla.attach(self.contra1,2,6,3,4,True,True,0)
        
        
        
        
        barrabotones=self.creaCajaBotones(True,gtk.BUTTONBOX_SPREAD,30)
        tabla.attach(barrabotones,0,8,7,8,True,True,0)      
        
        
        botonok=self.creaBoton(None,gtk.STOCK_OK,30,30)
        barrabotones.add(botonok)
        botonok.connect("clicked",self.compruebaPass,None)
        
        
        
        botonayuda=self.creaBoton(None,gtk.STOCK_HELP,30,30)
        barrabotones.add(botonayuda)
        botonayuda.connect("clicked",self.ayudar,None)

        botonprobar=self.creaBoton("Probar un archivo de audio",None,200,30)
        barrabotones.add(botonprobar)
        botonprobar.connect("clicked",self.explorar_archivo,None)
        
    
        botonsalir = gtk.Button()
        imagensalir= self.creaImagen("./iconos/salir.png")
        botonsalir.add(imagensalir)
        botonsalir.show()
        barrabotones.add(botonsalir)
        botonsalir.connect("clicked",self.borradoevento,self.ventanaclave)

    
        self.ventanaclave.connect("delete_event",self.borradoevento)
        self.ventanaclave.connect("destroy",self.destruir,None)
 
    def explorar_archivo(self,widget,data):
#        config = ConfigParser.ConfigParser()
#        fich_conf=os.path.expanduser("~") + "/" + ".agencia_default.cfg"

        ruta_ant=config.get('Ruta','ruta_ant')

        dialog = gtk.FileChooserDialog("Open..",
                                None,
                               gtk.FILE_CHOOSER_ACTION_OPEN,
                               (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                gtk.STOCK_OPEN, gtk.RESPONSE_OK))

        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_current_folder(ruta_ant)
        filter = gtk.FileFilter()

        filter.set_name("Audios")

        filter.add_pattern("*.mp3")
        dialog.add_filter(filter)

        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            print dialog.get_filename(), 'selected'
            config.set("Ruta", "ruta_ant",dialog.get_current_folder())
            if config.get("Prueba","test")!="Satisfactorio":
                config.set("Prueba","test", "True")
                f = open(fich_conf, "w")
                config.write(f)
                f.close()
                
            try:
                #os.remove(os.path.join(dir_tmp,"listening1.wav"))
                for archivo_viejo in ("listening1.wav","listening1.mp3"):
                    ruta_vieja=os.path.join(dir_tmp,archivo_viejo)
                    if os.path.exists(ruta_vieja):
                        temp_file= tempfile.mktemp(dir=dir_tmp)
                        os.rename(ruta_vieja,temp_file)
                        os.remove(temp_file)

            except:
                pass

            shutil.copy2(dialog.get_filename(),os.path.join(dir_tmp,"listening1.mp3"))
            self.reproductor(self.ventanaclave, "Prueba de audio personal")
            

            dialog.destroy()
        elif response == gtk.RESPONSE_CANCEL:
            print 'Closed, no files selected'
            dialog.destroy()
            
            
    def compruebaPass(self,widget,data):
        p1 = self.contra1.get_text()        
        texto=""
        #borro archivos anteriores si existieran:
        try:
            #os.remove(os.path.join(dir_tmp,"listening1.wav")) 
            for archivo_viejo in ("listening1.wav","listening1.mp3"):
                ruta_vieja=os.path.join(dir_tmp,archivo_viejo) 
                if os.path.exists(ruta_vieja):
                    temp_file= tempfile.mktemp(dir=dir_tmp)
                    os.rename(ruta_vieja,temp_file)
                    os.remove(temp_file)
                    
        except:
            pass    

            
        def busca_zip_correcto(ruta_audio):  
            texto1=""       
            if p1=="":return texto1
            archivos_audio= glob.glob(os.path.join(ruta_audio,"*.zip"))
            subprocess.call(["rm","-f",os.path.join(dir_tmp,"listening1.mp3")])

            if len(archivos_audio)>0:
                for ruta_comp in archivos_audio:
                    try:
                        #Esta comentado utilizando la librería zipfile, pero es muy lenta
                        #import zipfile
                        #myzip = zipfile.ZipFile(ruta_comp, 'r')
                        #myzip.extract("listening1.mp3", dir_tmp, p1)
                        #myzip.close()                              
                        
                        salida = os.system("unzip -oP " + p1 + " " + ruta_comp + " -d " + '"' + dir_tmp + '"')
                        if salida != 0:
                            raise RuntimeError()
                        else:
                            texto1 = "Prueba de comprensión oral."
                            if os.path.basename(ruta_comp)=="AudioPrueba.zip" and config.get("Prueba","test") !="Satisfactorio":
                                config.set("Prueba","test", "True")
                                f=open(fich_conf,"w")
                                config.write(f)
                                f.close()
                                print config.get("Prueba","test")             
                            nombre_mp3=zipfile.ZipFile(ruta_comp).namelist()[0]
                            subprocess.call(["mv","-f",os.path.join(dir_tmp,nombre_mp3),os.path.join(dir_tmp,"listening1.mp3")])
                            break                            
                    except:
                        pass #para buscar otro archivo con la contraseña correcta  
            return texto1


        directorio_sonidos=os.path.expanduser("~/sonido")

        #si ha escrito contraseña primero buscamos los posibles zip encriptados:
        if p1!='':
            # buscamos zip en el home del usuario, carpeta sonido:
            texto=busca_zip_correcto(directorio_sonidos)
            #si no hay zip en el home del usuario, los buscamos en la ruta donde está la aplicación:
            if texto=="":
                print "No se han encontrado zip correctos en el home del usuario"
                texto=busca_zip_correcto(os.path.join(os.path.curdir,"sonido"))
                if texto=="":
                    print "No se han archivos encriptados con contraseña"
        else:                   
            #Buscamos mp3 en el home del usuario, carpeta sonido
            archivos_audio=glob.glob(os.path.join(directorio_sonidos,'*.mp3'))
                        
            if len(archivos_audio)>0:
                texto = "Prueba de comprensión oral."
                #copiamos el primer mp3 que se encuentra:
                try:
                    shutil.copy2(os.path.join(directorio_sonidos,archivos_audio[0]),os.path.join(dir_tmp,"listening1.mp3"))
                except:
                    print "problemas copiando el archivo %s" % os.path.join(directorio_sonidos,archivos_audio[0])
                        
        if texto=="":
            print "No se han encontrado mp3 en el home de usuario ni zip encriptados en la ruta de la aplicación"
        else:
            self.reproductor(self.ventanaclave, texto)
            
         
            
    def __init__(self):
        '''
        self.ventanappal=self.crearVentana("Prueba de comprensión oral",320,300)
        #self.ventanappal.maximize()
        self.winmp3=False
        tabla=self.creaTabla(6,6,False)
        self.ventanappal.add(tabla)
        botonentrar=self.creaBoton("Entrar",None,150,50)
        tabla.attach(botonentrar,2,3,2,6,True,True,0)
        botonentrar.connect("clicked",self.pedirClave,None)


        image = gtk.Image()
        pixbuf = gtk.gdk.pixbuf_new_from_file("./iconos/edexcomprension.jpg")
        #scaled_buf = pixbuf.scale_simple(150,150,gtk.gdk.INTERP_BILINEAR)
        scaled_buf = pixbuf.scale_simple(400,400,gtk.gdk.INTERP_BILINEAR)
        image.set_from_pixbuf(scaled_buf)
        image.show()
        
        tabla.attach(image,1,3,1,3,True,True,0)

        self.ventanappal.connect("delete_event",self.borradoevento)
        self.ventanappal.connect("destroy",self.destruir,None)
        '''
        self.winmp3=False
        
        self.ventanappal=self.crearVentana("Prueba de comprensión oral",320,300)        
        tabla=self.creaTabla(6,6,False)        
        self.ventanappal.add(tabla)                           
        barraInicio=self.creaCajaBotones(False,gtk.BUTTONBOX_EDGE,30)
        
        botonentrar=self.creaBoton("Entrar",None,150,50)
        botonentrar.connect("clicked",self.pedirClave,None)


        image = gtk.Image()
        pixbuf = gtk.gdk.pixbuf_new_from_file("./iconos/edexcomprension.jpg")
        scaled_buf = pixbuf.scale_simple(400,400,gtk.gdk.INTERP_BILINEAR)
        image.set_from_pixbuf(scaled_buf)
        image.show()                
        
        tabla.attach(image,2,3,1,3,True,True,0)
        
        barraInicio.add(botonentrar)
        tabla.attach(barraInicio,1,7,5,6,True,True,0)   

        self.ventanappal.connect("delete_event",self.borradoevento)
        self.ventanappal.connect("destroy",self.destruir,None)
        
         
    def main(self):
        gtk.main()

if __name__ == "__main__":
    base = listening()
    base.main()
    print "prueba"
